export declare type Handler<T = unknown> = (event: T) => void;
export declare type EventHandlerList<T = unknown> = Array<Handler<T>>;
export declare type EventHandlerMap<Events extends {
    [key: string]: any;
}> = Map<keyof Events, EventHandlerList<Events[keyof Events]>>;
export interface Emitter<Events extends {
    [key: string]: any;
}> {
    all: EventHandlerMap<Events>;
    on<Key extends keyof Events>(type: Key, handler: Handler<Events[Key]>): void;
    off<Key extends keyof Events>(type: Key, handler?: Handler<Events[Key]>): void;
    emit<Key extends keyof Events>(type: Key, event?: Events[Key]): void;
}
/**
 * Credits to mit
 */
export default function eventBus<Events extends {
    [key: string]: any;
}>(all?: EventHandlerMap<Events>): Emitter<Events>;
