"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pipe = exports.noop = void 0;
const noop = () => { };
exports.noop = noop;
function pipe(...fns) {
    const mainCallback = fns.pop();
    return (...args) => {
        let nextFunc = exports.noop;
        let currentArgs = args;
        for (let i = fns.length - 1; i >= 0; i--) {
            nextFunc = fns[i].bind(null, nextFunc, ...currentArgs);
        }
        return mainCallback(nextFunc, ...args);
    };
}
exports.pipe = pipe;
//# sourceMappingURL=Function.js.map