export declare enum LifeCycleEvent {
    BeforeAll = "BeforeAll",
    OnInit = "OnInit",
    OnDispose = "OnDispose",
    AfterAll = "AfterAll"
}
export declare function isLifeCycleEvent(name: string): boolean;
export declare function lifeCycleEventName<T extends LifeCycleEvent>(name: T): `@${T}`;
export declare type LifeCycleEventsMap = {
    [K in LifeCycleEvent as `@${K}`]: {
        store: any;
    };
};
export declare type StoreLifeCycleEventsMap = {
    [K in LifeCycleEvent as `${string}.@${K}`]: {
        store: any;
    };
};
export interface LifeCycleEvents extends LifeCycleEventsMap, StoreLifeCycleEventsMap {
}
