import ts from 'typescript';
import { CodeSnippet } from "./ErrorMessages";
declare type LintingMessageType = 'error' | 'warning' | 'info';
interface LintingMessage {
    type: LintingMessageType;
    messages: string | string[] | (string | CodeSnippet)[];
    start: number;
    end: number;
    codeSnippet: null | {
        code: string;
        location: string;
        startLine: number;
    };
}
export declare class Linter {
    isMainInstance: boolean;
    static messages: LintingMessage[];
    private _sourceFile;
    private _messages;
    constructor(isMainInstance?: boolean);
    factory(sourceFile: ts.SourceFile): Linter;
    merge(): void;
    info(messages: string | string[] | (string | CodeSnippet)[], node: ts.Node): void;
    warn(messages: string | string[] | (string | CodeSnippet)[], node: ts.Node): void;
    error(messages: string | string[] | (string | CodeSnippet)[], node: ts.Node): void;
    private _add;
    reset(): void;
    print(): void;
}
export declare const Linting: Linter;
export {};
