"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasDecorator = exports.isPublicOrPrivate = exports.isStatic = void 0;
const typescript_1 = __importDefault(require("typescript"));
function isStatic(modifiers) {
    return modifiers === null || modifiers === void 0 ? void 0 : modifiers.some(m => m.kind === typescript_1.default.SyntaxKind.StaticKeyword);
}
exports.isStatic = isStatic;
function isPublicOrPrivate(modifiers) {
    if (!modifiers) {
        return true;
    }
    return modifiers === null || modifiers === void 0 ? void 0 : modifiers.some(m => { return m.kind === typescript_1.default.SyntaxKind.PublicKeyword || m.kind === typescript_1.default.SyntaxKind.PrivateKeyword; });
}
exports.isPublicOrPrivate = isPublicOrPrivate;
function hasDecorator(node, name) {
    var _a, _b;
    if (!((_a = node === null || node === void 0 ? void 0 : node.modifiers) === null || _a === void 0 ? void 0 : _a.length)) {
        return false;
    }
    return (_b = node.modifiers) === null || _b === void 0 ? void 0 : _b.some(m => {
        var _a, _b, _c, _d, _e;
        if (!typescript_1.default.isDecorator(m))
            return false;
        if (typescript_1.default.isCallExpression(m.expression)) {
            return ((_c = (_b = (_a = m.expression) === null || _a === void 0 ? void 0 : _a.expression) === null || _b === void 0 ? void 0 : _b.getText()) === null || _c === void 0 ? void 0 : _c.toLowerCase()) === name.toLowerCase();
        }
        if (typescript_1.default.isIdentifier(m.expression)) {
            return ((_e = (_d = m.expression) === null || _d === void 0 ? void 0 : _d.getText()) === null || _e === void 0 ? void 0 : _e.toLowerCase()) === name.toLowerCase();
        }
        return false;
    });
}
exports.hasDecorator = hasDecorator;
//# sourceMappingURL=Modifiers.js.map