"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConstVariableNode = void 0;
const typescript_1 = __importDefault(require("typescript"));
const Object_1 = require("./Object");
const { factory } = typescript_1.default;
function createConstVariableNode(name, value, isNode = false, isExport = false) {
    const node = isNode ? value : (0, Object_1.createNodeFromValue)(value);
    return factory.createVariableStatement(isExport ? [factory.createModifier(typescript_1.default.SyntaxKind.ExportKeyword)] : undefined, factory.createVariableDeclarationList([
        factory.createVariableDeclaration(factory.createIdentifier(name), undefined, undefined, node)
    ], typescript_1.default.NodeFlags.Const));
}
exports.createConstVariableNode = createConstVariableNode;
//# sourceMappingURL=Nodes.js.map