import ts from 'typescript';
import { Linter } from "../Linting";
import { ActionMeta } from "../Meta/ActionMeta";
import { StoreMeta } from "../Meta/StoreMeta";
export declare class ProcessingContextInstance {
    linter: Linter;
    /**
     * The module that's currently being processed
     */
    module: ts.SourceFile;
    /**
     * The store that we're currently processing
     */
    store: StoreMeta;
    /**
     * The class that's currently being processed
     */
    classDeclaration: ts.ClassDeclaration;
    /**
     * The method that is currently being processed, if we're processing one.
     */
    methodDeclaration: ts.MethodDeclaration;
    action: ActionMeta;
    setCurrent(module: ts.SourceFile, store: StoreMeta): void;
    validate(): void;
    processingStoreClass(classDeclaration: ts.ClassDeclaration, handlerFunc: () => void): void;
    /**
     * We use a callback here so that we can temporarily set the method
     * on the context, and remove it again once we're done
     */
    processingAction(action: ActionMeta, handlerFunc: () => void): void;
}
export declare const ProcessingContext: ProcessingContextInstance;
